package org.this_voice.modabrowser;

import android.content.Intent;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;
import java.net.URLEncoder;
import java.util.Calendar;
import java.io.UnsupportedEncodingException;

public class AddEditBlog extends Activity {

	private boolean doubleBackPressedOnce = false;

	public ImageButton CancelBlog;
	public ImageButton CommitBlog;
    public EditText BlogURL;
    public EditText BlogName;
    public TextView LabelURL;
    public TextView LabelName;
    public TextView title;

	private Intent intent = new Intent();
	private String name = "";
	private String url = "";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent i = getIntent();
		name = i.getStringExtra("NAME");
		url = i.getStringExtra("URL");

		setContentView(R.layout.activity_addeditblog);
		findViews();
		BlogName.setText(name);
		BlogURL.setText(url);
	}

	public void commitBlog(View view){
		String blogName = BlogName.getText().toString();
		String blogURL = BlogURL.getText().toString();
		String blog = blogName+"\t"+blogURL;
		intent.putExtra("BLOG",blog);
		setResult(RESULT_OK, intent);
		finish();
	}

	public void cancelBlog(View view){
		cancel();
	}

	public void cancel(){
		setResult(RESULT_CANCELED, intent);
		finish();
	}


	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		CancelBlog = (ImageButton) findViewById(R.id.CancelBlog);
		CommitBlog = (ImageButton) findViewById(R.id.CommitBlog);
		BlogURL = (EditText) findViewById(R.id.BlogURL);
		BlogName = (EditText) findViewById(R.id.BlogName);
		LabelURL = (TextView) findViewById(R.id.LabelURL);
		LabelName = (TextView) findViewById(R.id.LabelName);
	}


	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			setResult(RESULT_CANCELED, intent);
			finish();
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, getResources().getString(R.string.exit_bkbtn) ,
					   Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


}
