package org.this_voice.modabrowser;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

/**
 * Annotate.java created and copyrighted: 13 April 13
 * 
 * author: R. Earle Harris (richard.earle.harris@gmail.com)
 * 
 * The author releases this file under the GNU GPL license. See GNU's COPYING
 * file for specifics.
 **/

import android.widget.Toast;
import android.os.Handler;
import java.lang.Runnable;

public class Annotate extends Activity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public String node;
	public String ctxt;
	public String fname;

	public ImageButton Save;
	public ImageButton Cancel;
	public TextView title;
	public EditText editor;
	public InputMethodManager mgr;

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		Save = (ImageButton) findViewById(R.id.btnSave);
		Cancel = (ImageButton) findViewById(R.id.btnCancel);
		editor = (EditText) findViewById(R.id.editor);
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_annotate);
		findViews();
		mgr = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		final Intent origin = getIntent();
		node = origin.getStringExtra("NODE");
		ctxt = origin.getStringExtra("CONTEXT");
		ctxt = ctxt.replace("context","");
		fname = Integer.toString(node.hashCode());
		fname = fname.replace('-', 'm');
		fname = ctxt+fname;

		final String[] orig = fhandler.getFileAsArray(fname);
		String content = "";
		for (final String s : orig) {
			content = content + s + "\n";
		}
		editor.setText(content);
	}

	

	public void save(View view) {
		toaster(getResources().getString(R.string.svannot), Toast.LENGTH_SHORT);
		final List<String> list = new ArrayList<String>();
		final String text = editor.getText().toString();
		list.add(text);
		fhandler.writeListToFile(list, fname);
		finish();
	}

	public void cancel(View view) {
		finish();
	}


    // length gets Toast.LENGTH_LONG|SHORT
	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	
    public void showKbd(View view) {
		if(!(mgr==null)) mgr.showSoftInput(editor, InputMethodManager.SHOW_IMPLICIT);
    }

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
