package org.this_voice.modabrowser;

import android.content.Intent;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;
import java.net.URLEncoder;
import java.util.Calendar;
import java.io.UnsupportedEncodingException;

public class BlogPost extends Activity {

	private boolean doubleBackPressedOnce = false;

	public ImageButton CancelPost;
	public ImageButton CommitPost;
    public EditText PostContent;
    public EditText PostTitle;
    public TextView LabelContent;
    public TextView LabelTitle;
    public TextView title;

	private Intent intent = new Intent();
	private String link;
	private String name;
	private String url;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent i = getIntent();
		name = i.getStringExtra("NAME");
		url = i.getStringExtra("URL");
		link = i.getStringExtra("LINK");

		setContentView(R.layout.activity_blogpost);
		findViews();
		String tmp = title.getText().toString();
		title.setText(tmp + name);
		PostContent.setText(link);
	}

	public void commitPost(View view){
		String postTitle = PostTitle.getText().toString();
		String postContent = PostContent.getText().toString();
		try {
			postTitle = URLEncoder.encode(postTitle,"UTF-8");
			postContent = URLEncoder.encode(postContent,"UTF-8");
		} catch (UnsupportedEncodingException u) { cancel(); }
		url = url.replace("$TITLE", postTitle);
		url = url.replace("$CONTENT", postContent);
		long fn = System.currentTimeMillis ();
		String fname = Long.toString(fn);
		url = url.replace("$SECONDS", fname);
		Calendar rightNow = Calendar.getInstance();
		int mo = rightNow.get(Calendar.MONTH);
		mo++;
		String month = Integer.toString(mo);
		if (month.length() == 1){
			month = "0"+month;
		}
		url = url.replace("$MONTH", month);
		intent.putExtra("URL",url);
		setResult(RESULT_OK, intent);
		finish();
		
	}

	public void cancelPost(View view){
		cancel();
	}

	public void cancel(){
		setResult(RESULT_CANCELED, intent);
		finish();
	}


	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		CancelPost = (ImageButton) findViewById(R.id.CancelPost);
		CommitPost = (ImageButton) findViewById(R.id.CommitPost);
		PostContent = (EditText) findViewById(R.id.PostContent);
		PostTitle = (EditText) findViewById(R.id.PostTitle);
		LabelContent = (TextView) findViewById(R.id.LabelContent);
		LabelTitle = (TextView) findViewById(R.id.LabelTitle);
	}


	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			setResult(RESULT_CANCELED, intent);
			finish();
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, getResources().getString(R.string.exit_bkbtn), 
					   Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


}
