package org.this_voice.modabrowser;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.text.InputType;
import android.view.Gravity;
import android.view.View.OnLongClickListener;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings.PluginState;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import android.content.res.Configuration;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Arrays;
import java.util.List;
import java.lang.Exception;
import java.lang.NullPointerException;


/**
 * MoDa.java created and copyrighted: 4 April 13
 *
 * author: R. Earle Harris (richard.earle.harris@gmail.com)
 *
 * The author releases this file under the GNU GPL license. See GNU's COPYING
 * file for specifics.
 **/

@SuppressLint("SetJavaScriptEnabled")
public class MoDaBrowser extends Activity {

	final MoDaBrowser mMoDa = this;
	final static int OPEN_CONTEXT = 0;
	final static int BLOG_POST = 1;
	final static String SEARCH = 
		"http://startpage.com/do/search?language=english&cat=web&query=";
	final static List<String> dnlds = Arrays.asList("apk", "bz2", "gz", "jpeg",
			"jpg", "mp3", "ogg", "pdf", "png", "tgz", "zip");

	public File download_dir;
	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public String currentContext = "contextMoDa";
	public String last_search = "";
	public String sep = "\t"; // must be invalid URL char
	public boolean contextTravel = false;
	public boolean fan = false;

	public ImageButton AddNode;
	public ImageButton Email;
	public ImageButton MoDa;
	public ImageButton Post;
	public ImageButton Refresh;
	public ImageButton Search;
	public ImageButton TwoStep;
	public ImageButton Url;
	public MoDaView wv;
	public ProgressBar progress;
	public TextView title;

	/**
	 * mWVC Class
	 */

	private class mWVC extends WebViewClient {

		@Override
		public void onPageFinished(WebView view, String url) {
			// fix for blank results on Google search links
			if ("about:blank".equals(url) && (view.getTag() != null)) {
				view.loadUrl(view.getTag().toString()); // get last page
			} else {
				view.setTag(url); // set last page
			}
		}


		@Override
		public void onReceivedError(WebView view, int errorCode, String description, 
									String failingUrl) {
			boolean fixed = false;
			try {
				view.loadUrl(view.getTag().toString());
				fixed = true;
			} catch (NullPointerException e) { ; }

			if ((!fixed) && (view.canGoBack())) {
				view.invalidate();
				view.goBack();
			}

			toaster(description, Toast.LENGTH_SHORT);
		}

		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url) {

			if (!isOnline())
				return true;

			url = url.trim();
            if (url.startsWith("tel:")) {
                Intent intent = new Intent(Intent.ACTION_DIAL,
                        Uri.parse(url));
                startActivity(intent);
				return true;
            }else if (url.startsWith("mailto:")) {
				String[] emailUri = url.split(":");
				Intent emailIntent = new Intent(
						android.content.Intent.ACTION_SEND);
				emailIntent.setType("text/plain");
				emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL,
						new String[] { emailUri[1] });
				startActivity(emailIntent);
				return true;
			} else if (url.contains("play.google.com")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK
						| Intent.FLAG_ACTIVITY_CLEAR_TOP
						| Intent.FLAG_ACTIVITY_NO_ANIMATION);
				startActivity(intent);
				return true;
			} else {
				String ext = getExtension(url);
				if (dnlds.contains(ext)) {
					AlertDialog.Builder b = new AlertDialog.Builder(
							view.getContext());
					b.setTitle("Download?");
					TextView input = new TextView(view.getContext());
					input.setText(url);
					b.setView(input);
					final String f_url = url;
					b.setPositiveButton("Go",
							new DialogInterface.OnClickListener() {
								@Override
								public void onClick(DialogInterface dialog,
										int whichButton) {
									progress.setProgress(0);
									progress.setVisibility(View.VISIBLE);
									DownloadFile downloadFile = new DownloadFile();
									downloadFile.execute(f_url);
								}
							});
					b.setNegativeButton("Cancel", null);
					b.create().show();

					return true;
				} else {

					// stop button handling
					MoDa.setBackgroundResource(R.drawable.icon_stop);
					MoDa.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							wv.stopLoading();
							int amt = progress.getProgress();
							if ((amt > 50) && (amt < 80) && (wv.canGoBack())) {
								wv.goBack();
							}
						}
					});

					progress.setProgress(0);
					progress.setVisibility(View.VISIBLE);
					wv.setWebChromeClient(new WebChromeClient() {
						@Override
						public void onProgressChanged(WebView view, int amt) {
							progress.setProgress(amt);
							if (amt == 100) {
								progress.setVisibility(View.GONE);
								MoDa.setBackgroundResource(R.drawable.icon_moda);
								MoDa.setOnClickListener(new View.OnClickListener() {
									@Override
									public void onClick(View v) {
										toggleFan();
									}
								});
							}
						}

					});

					try {
						wv.loadUrl(url);
					} catch (Exception e) {
						toaster(e.getMessage(), Toast.LENGTH_SHORT);
						return false;
					}
					return true;
				}
			}
		}
	}

	/**
	 * MoDa Class
	 */

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// prep sdcard
		download_dir = Environment
				.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);

		getWindow().requestFeature(Window.FEATURE_PROGRESS);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		setContentView(R.layout.activity_mo_da);

		findViews();

		Url.setBackgroundResource(R.drawable.icon_url);
		Refresh.setBackgroundResource(R.drawable.icon_refresh);
		AddNode.setBackgroundResource(R.drawable.icon_addnode);
		Search.setBackgroundResource(R.drawable.icon_search);
		TwoStep.setBackgroundResource(R.drawable.icon_twostep);
		Email.setBackgroundResource(R.drawable.icon_email);
		Post.setBackgroundResource(R.drawable.icon_post);

		// Primary Button
		MoDa.setLongClickable(true);
		MoDa.setBackgroundResource(R.drawable.icon_moda);
		MoDa.setOnLongClickListener(new OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) {
				toggleTravel();
				return true;
			}
		});
		MoDa.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				toggleFan();
			}
		});

		WebSettings wvOptions = wv.getSettings();
		wvOptions.setJavaScriptEnabled(true);
		wvOptions.setGeolocationEnabled(false);
		wvOptions.setBuiltInZoomControls(true);
		wvOptions.setUseWideViewPort(true);
		wvOptions.setPluginState(PluginState.ON);
		wvOptions.setSupportMultipleWindows(false);
		wvOptions.setSaveFormData(true);
		wvOptions.setMinimumFontSize(10);
		wv.setFocusable(true);
		wv.setFocusableInTouchMode(true);
		wv.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
		wv.setWebViewClient(new mWVC());
		wv.clearCache(true);
		wv.setLongClickable(true);
		wv.setMoDa(this);
		wv.setOnLongClickListener(new OnLongClickListener() {

			@Override
			public boolean onLongClick(View view) {
				Intent intent = new Intent(mMoDa, OpenContext.class);
				intent.putExtra("CONTEXT", currentContext);
				startActivityForResult(intent, OPEN_CONTEXT);
				return true;
			}
		});

		isOnline();

		Intent intent = getIntent();
		String action = intent.getAction();
		String scheme = intent.getScheme();

		if (Intent.ACTION_VIEW.equals(action) && (scheme != null)
				&& scheme.startsWith("http")) {
			String url = intent.getData().toString();
			wv.loadUrl(url);
		} else {
			wv.loadUrl("file:///android_asset/index.html");
		}

		new SimpleEula(this).show();
	}

	// Letting activities call wv.loadUrl bypasses mWVC
	public void loadPage4Activity(String url){
		if ((!url.matches("none") && (isOnline()))) {
			MoDa.setBackgroundResource(R.drawable.icon_stop);
			MoDa.setOnClickListener(new View.OnClickListener() {
					@Override
						public void onClick(View v) {
						wv.stopLoading();
						int amt = progress.getProgress();
						if ((amt > 50) && (amt < 80)
							&& (wv.canGoBack())) {
							wv.goBack();
						}
					}
				});
			progress.setProgress(0);
			progress.setVisibility(View.VISIBLE);
			wv.setWebChromeClient(new WebChromeClient() {
					@Override
						public void onProgressChanged(WebView view, int amt) {
						progress.setProgress(amt);
						if (amt == 100) {
							progress.setVisibility(View.GONE);
							MoDa.setBackgroundResource(R.drawable.icon_moda);
							MoDa.setOnClickListener(new View.OnClickListener() {
									@Override
										public void onClick(View v) {
										toggleFan();
									}
								});
						}
					}
				});
			wv.loadUrl(url);
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_OK) {
			if (requestCode == OPEN_CONTEXT) {
				String url = data.getStringExtra("URL");
				currentContext = data.getStringExtra("CONTEXT");
				if (contextTravel){
					wv.reloadContext(currentContext);
				}
				loadPage4Activity(url);
			} else if (requestCode == BLOG_POST) {
				String url = data.getStringExtra("URL");
				loadPage4Activity(url);
			}
		}
	}

	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	public void toggleTravel(){
		contextTravel = !contextTravel;
		wv.toggleTravel(currentContext);
	}


	/**
	 *    Fan Methods
	 **/


	public void modaRefresh(View view) {
		wv.reload();
		toggleFan();
		toaster(getResources().getString(R.string.reloading), Toast.LENGTH_SHORT);
	}


	public void modaAddNode(View view) {
		toggleFan();

		String title;
		try {
			title = wv.getTitle();
		} catch (Exception e) {
			title = "";
		}

		if ((title == null) || (title.matches(""))) {
			title = "none";
		}

		AlertDialog.Builder b = new AlertDialog.Builder(this);
		b.setTitle("New Node");
		final EditText input = new EditText(this);
		input.setText(title);
		input.setInputType(InputType.TYPE_CLASS_TEXT);
		b.setView(input);
		b.setMessage("Accept or Rename.\nCancel aborts node.");
		b.setPositiveButton("Set Name", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int whichButton) {

				String name = input.getText().toString();
				String line = name.trim() + sep + wv.getUrl().trim();
				fhandler.writeUniqLineByTokens(currentContext, line, sep);
			}
		});
		b.setNegativeButton("Cancel", null);
		b.create().show();

	}


	//  doubled up for clear call from dialog
	public void modaSearch(View view) {
		if (isOnline()){
			search();
		}
	}

	private void search() {
		toggleFan();
		AlertDialog.Builder b = new AlertDialog.Builder(this);
		b.setTitle("Search");
		final EditText input = new EditText(this);
		input.setText(last_search);
		input.setImeOptions(EditorInfo.IME_ACTION_GO);
		input.setRawInputType(InputType.TYPE_CLASS_TEXT
				| InputType.TYPE_TEXT_VARIATION_URI);

		b.setView(input);
		b.setPositiveButton("Go", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int whichButton) {

				String query = input.getText().toString();
				last_search = query;
				query = Uri.encode(query);
				String url = SEARCH + query;

				wv.setWebViewClient(new mWVC());
				wv.loadUrl(url);
			}
		});
		b.setNeutralButton("Clear", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int whichButton) {
				last_search = "";
				toggleFan();
				search();
			}
		});
		b.setNegativeButton("Cancel", null);
		b.create().show();
	}

	public void modaTwoStep(View view) {
		toggleFan();
		wv.toggleTwoStep();
	}


	public void modaUrl(View view) {
		toggleFan();
		if (isOnline()) {
			modaURL(true);
		}
	}

	//  useCurrent for clear call from dialog
	private void modaURL(boolean useCurrent) {

		String this_page = wv.getOriginalUrl();
		if (!useCurrent || !this_page.startsWith("http")) {
			this_page = "";
		}
		
		AlertDialog.Builder b = new AlertDialog.Builder(this);
		b.setTitle("Enter URL");
		final EditText input = new EditText(this);
		input.setText(this_page);
		input.setInputType(InputType.TYPE_CLASS_TEXT
						   | InputType.TYPE_TEXT_VARIATION_URI);
		b.setView(input);
		b.setPositiveButton("Go", new DialogInterface.OnClickListener() {
				@Override
					public void onClick(DialogInterface dialog, int whichButton) {
					
					String url = input.getText().toString();
					url = url.trim();
					if (!url.startsWith("http")) {
						url = "http://" + url;
					}
					
					wv.setWebViewClient(new mWVC());
					wv.loadUrl(url);
				}
			});
		b.setNeutralButton("Clear", new DialogInterface.OnClickListener() {
				@Override
					public void onClick(DialogInterface dialog, int whichButton) {
					modaURL(false);
				}
			});
		b.setNegativeButton("Cancel", null);
		b.create().show();
	}


	public void modaPost(View view) {
		if (isOnline()){
			toggleFan();
			String title = wv.getTitle();
			if ((title == null) || (title.matches(""))) {
				title = "MISSING TITLE";
			}
			String url = wv.getUrl();
			String link = "\n\n<br><a href=\""+url+"\">"+title+"</a>" + 
				"\n<br>    ::shared from Mo Da Browser::";
			Intent i = new Intent(this, ChooseBlog.class);
			i.putExtra("LINK",link);
			startActivityForResult(i, BLOG_POST);
		}
	}

	public void modaEmail(View view) {
		String title = wv.getTitle();

		if ((title == null) || (title.matches(""))) {
			title = "MISSING TITLE";
		}

		String url = wv.getUrl();
		Intent emailIntent = new Intent(
				android.content.Intent.ACTION_SEND);
		emailIntent.putExtra(android.content.Intent.EXTRA_SUBJECT,
				"Link to Web Page: "+title);
		emailIntent.putExtra(android.content.Intent.EXTRA_TEXT,
							 "\n\n<a href=\""+url+"\">"+title+"</a>" + 
							 "\n\n    ::shared from Mo Da Browser::");
		emailIntent.setType("text/plain");
		startActivity(Intent.createChooser(emailIntent, "Send page to ..."));
		toggleFan();
	}

	private void toggleFan() {
		fan = !fan;
		int i;
		if (fan) {
			i = View.GONE;
		} else {
			i = View.VISIBLE;
		}
		Refresh.setVisibility(i);
		AddNode.setVisibility(i);
		Search.setVisibility(i);
		TwoStep.setVisibility(i);
		Url.setVisibility(i);
		Email.setVisibility(i);
		Post.setVisibility(i);
	}



	/**
	 * download asynctask
	 */
	private class DownloadFile extends AsyncTask<String, Integer, String> {
		@Override
		protected String doInBackground(String... sUrl) {
			URL url;
			try {
				url = new URL(sUrl[0]);
			} catch (MalformedURLException e1) {
				return "Error: Bad URL";
			}
			String fname = url.toString().substring(
					url.toString().lastIndexOf('/') + 1);
			try {
				URLConnection connection = url.openConnection();
				connection.connect();
				int fileLength = connection.getContentLength();

				InputStream input = new BufferedInputStream(
						url.openStream());
				OutputStream output = new FileOutputStream(download_dir
						+ "/" + fname);

				byte data[] = new byte[1024];
				long total = 0;
				int count;
				while ((count = input.read(data)) != -1) {
					total += count;
					publishProgress((int) ((total * 100) / fileLength));
					output.write(data, 0, count);
				}

				output.flush();
				output.close();
				input.close();
			} catch (Exception e) {
				return "ERROR: download failed";
			}
			return fname;
		}

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			progress.setProgress(0);
			progress.setVisibility(View.VISIBLE);
		}

		@Override
		protected void onProgressUpdate(Integer... progress) {
			super.onProgressUpdate(progress);
			getWindow().setFeatureInt(Window.FEATURE_PROGRESS, progress[0]);
		}

		@Override
		protected void onPostExecute(String result) {
			progress.setVisibility(View.GONE);
			toaster(getResources().getString(R.string.downloaded) +
					": " + result, Toast.LENGTH_SHORT);
		}

	}// end asynctask

	/**
	 * Utilities
	 */

	public int indexOfLastSeparator(String filename) {
		if (filename == null)
			return -1;
		int lastUnixPos = filename.lastIndexOf("/");
		int lastWindowsPos = filename.lastIndexOf("\\");
		return Math.max(lastUnixPos, lastWindowsPos);
	}

	public int indexOfExtension(String filename) {
		if (filename == null)
			return -1;
		int extensionPos = filename.lastIndexOf(".");
		int lastSeparator = indexOfLastSeparator(filename);
		return lastSeparator > extensionPos ? -1 : extensionPos;
	}

	public String getExtension(String filename) {
		if (filename == null)
			return null;
		int index = indexOfExtension(filename);
		if (index == -1)
			return "";
		else
			return filename.substring(index + 1);
	}

	public boolean isOnline() {
		ConnectivityManager cm = (ConnectivityManager) getBaseContext()
				.getSystemService(Context.CONNECTIVITY_SERVICE);

		NetworkInfo i = cm.getActiveNetworkInfo();
		if ((i == null) || (!i.isConnected())) {
			toaster(getResources().getString(R.string.isonline), Toast.LENGTH_SHORT);
			return false;
		}
		return true;
	}

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		progress = (ProgressBar) findViewById(R.id.progressbar);

		Url = (ImageButton) findViewById(R.id.Url);
		Refresh = (ImageButton) findViewById(R.id.Refresh);
		AddNode = (ImageButton) findViewById(R.id.AddNode);
		Search = (ImageButton) findViewById(R.id.Search);
		Email = (ImageButton) findViewById(R.id.Email);
		Post = (ImageButton) findViewById(R.id.Post);
		TwoStep = (ImageButton) findViewById(R.id.TwoStep);

		MoDa = (ImageButton) findViewById(R.id.MoDa);
		wv = (MoDaView) findViewById(R.id.webview);
	}

	/**
	 * Android States and Similar
	 */

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			wv.clearCache(true);
			super.onBackPressed(); // exit by super
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


}
